function likeiteration2(xparam1,gend,data,data_index,number_of_observations,no_more_missing_observations)
%Calculates LM statistics and runs composite tests

global oo_ lik J_MC_integration J_MC_reps

global point_list  output Qu_LM_prewhitened Qu_LM_PW_A

global  diff_precision estim_params Qu_LM_PW_output

global test_params calibrated_values steps

global  k2 data2 data_index2 number_of_observations2 no_more_missing_observations2

global testparam param J_store b0 options point_test

global likelihood_eval composite_test AM_LM Qu_LM AM_LM_output Qu_LM_output

global Jsim fixJ Jmean AM_LM_J_fixed paramvec

k=gend; %(# of observations)
number_of_observations1=number_of_observations;
steps=1;

if Jsim==1
    for n1=1:size(point_list,1)
        calibrated_values=point_list(n1,:)';
        DsgeLikelihood(calibrated_values,k,data,data_index,number_of_observations1,no_more_missing_observations);
        b0=lik;
        param=calibrated_values;
        loglike_list1=NaN(9,size(b0,1));
        loglike_list2=NaN(9,size(b0,1));
        for n=1:sum(estim_params)
            param1=param;
            param1(n)=param1(n)-diff_precision;
            param2=param;
            param2(n)=param2(n)+diff_precision;
            DsgeLikelihood(param1,k,data,data_index,number_of_observations1,no_more_missing_observations);
            b=lik;
            loglike_list1(n,:)=b';
            DsgeLikelihood(param2,k,data,data_index,number_of_observations1,no_more_missing_observations);
            b=lik;
            loglike_list2(n,:)=b';
        end
        s=(loglike_list2-loglike_list1)/(2*diff_precision);
        S=sum(s,2);
        J=s(:,1)*s(:,1)';
        for l=2:size(s,2)
            J=J+s(:,l)*s(:,l)';
        end
        
        J_store(:,:,n1)=J;
    end
    
else
    if likelihood_eval==1
        for n=1:size(point_list,1)
            DsgeLikelihood(point_list(n,:)',k,data,data_index,number_of_observations1,no_more_missing_observations);
            b=lik;
            output(n,:)=b;
        end
    elseif point_test==1
        for n1=1:size(point_list,1)
            if AM_LM==1
                calibrated_values=point_list(n1,:)';
                DsgeLikelihood(calibrated_values,k,data,data_index,number_of_observations1,no_more_missing_observations);
                b0=lik;
                param=calibrated_values;
                loglike_list1=NaN(9,size(b0,1));
                loglike_list2=NaN(9,size(b0,1));
                for n=1:sum(estim_params)
                    param1=param;
                    param1(n)=param1(n)-diff_precision;
                    param2=param;
                    param2(n)=param2(n)+diff_precision;
                    DsgeLikelihood(param1,k,data,data_index,number_of_observations1,no_more_missing_observations);
                    b=lik;
                    loglike_list1(n,:)=b';
                    DsgeLikelihood(param2,k,data,data_index,number_of_observations1,no_more_missing_observations);
                    b=lik;
                    loglike_list2(n,:)=b';
                end
                s=(loglike_list2-loglike_list1)/(2*diff_precision);
                S=sum(s,2);
                
                J=s(:,1)*s(:,1)';
                for l=2:size(s,2)
                    J=J+s(:,l)*s(:,l)';
                    
                end
                
                if rank(J)==size(J,1);
                    AM_LM_output(n1,1)=S'*J^-1*S;
                else
                    AM_LM_output(n1,1)=NaN;
                end
                AM_LM_J_fixed=S'*Jmean^-1*S;
                
            end
            
            if Qu_LM==1
                dstore=zeros(9,9,size(data,2));
                Y=[data(3,:)' data(1,:)' data(2,:)'];
                for n=1:sum(estim_params)
                    calibrated_values=point_list(n1,:)';
                    param=calibrated_values;
                    param1=param;
                    param1(n)=param1(n)-diff_precision;
                    param2=param;
                    param2(n)=param2(n)+diff_precision;
                    %Note: data ordered [x'; pie'; r']
                    
                    DsgeLikelihood(param1,k,data,data_index,number_of_observations1,no_more_missing_observations);
                    %sigma1=diag([param1(8) param1(7) param1(9)]);
                    sigma1=eye(3);
                    temp=oo_.dr.ghx;
                    Theta1=[zeros(6,1) temp zeros(6,2)];
                    %                     temp=oo_.dr.ghx;
                    %                     Theta1=[temp(:,1) zeros(6,1) temp(:,2:3) zeros(6,2)];
                    B=oo_.dr.ghu;
                    A=[0 1 0 0 0 0;...
                        0 0 0 0 1 0;...
                        0 0 0 0 0 1];
                    H1=@(w) A*(eye(6)-Theta1*w)^-1*B;
                    f1=@(w) 1/(2*pi)*H1(exp(-1i*w))*sigma1*H1(exp(-1i*w))';
                    DsgeLikelihood(param2,k,data,data_index,number_of_observations1,no_more_missing_observations);
                    
                    sigma2=eye(3);
                    temp=oo_.dr.ghx;
                    Theta1=[zeros(6,1) temp zeros(6,2)];
                    
                    B=oo_.dr.ghu;
                    A=[0 1 0 0 0 0;...
                        0 0 0 0 1 0;...
                        0 0 0 0 0 1];
                    H=@(w) A*(eye(6)-Theta1*w)^-1*B;
                    
                    f2=@(w) 1/(2*pi)*H(exp(-1i*w))*sigma2*H(exp(-1i*w))';
                    
                    df=@(w) (f2(w)-f1(w))/(2*diff_precision);
                    
                    count=(1:size(data,2))';
                    
                    
                    wvec=2*pi*count(1:end-1,:)/size(data,2);
                    
                    for m1=1:size(wvec,1);
                        d=df(wvec(m1));
                        dstore(:,n,m1)=transpose(d(1:end));
                    end
                end
                param=calibrated_values;
                DsgeLikelihood(param1,k,data,data_index,number_of_observations1,no_more_missing_observations);
                
                sigma0=eye(3);
                temp=oo_.dr.ghx;
                Theta1=[zeros(6,1) temp zeros(6,2)];
                
                
                B=oo_.dr.ghu;
                A=[0 1 0 0 0 0;...
                    0 0 0 0 1 0;...
                    0 0 0 0 0 1];
                H0=@(w) A*(eye(6)-Theta1*w)^-1*B;
                f0=@(w) 1/(2*pi)*H0(exp(-1i*w))*sigma0*H0(exp(-1i*w))';
                
                W=@(w) (2*pi*size(data,2))^-.5*transpose(sum(Y.*repmat(exp(-1i*count*w),1,3)));
                I=@(w) W(w)*W(w)';
                fprod=@(w) kron(transpose(f0(w)^-1),f0(w)^-1);
                %fprod=@(w) kron((f0(w)^-1)',f0(w)^-1);
                
                M=zeros(sum(estim_params),sum(estim_params));
                
                for m1=1:size(wvec,1)
                    M=M+8*pi^2*size(data,2)^-1*dstore(:,:,m1)'*fprod(wvec(m1))*dstore(:,:,m1);
                end
                
                D=zeros(sum(estim_params),1);
                for m1=1:size(wvec,1)
                    temp=I(wvec(m1))-f0(wvec(m1));
                    D=D+2*pi*size(data,2)^-.5*dstore(:,:,m1)'*fprod(wvec(m1))*transpose(temp(1:end));
                end
                Qu_LM_output(n1,1)=D'*pinv(M)*D;
                D1=D;
                M1=M;
                if Qu_LM_prewhitened==1
                    dstore=zeros(9,9,size(data,2)-1);
                    Y_base=[data(3,:)' data(1,:)' data(2,:)'];
                    Y=Y_base(2:end,:)'-Qu_LM_PW_A*Y_base(1:end-1,:)';
                    Y=Y';
                    for n=1:sum(estim_params)
                        calibrated_values=point_list(n1,:)';
                        param=calibrated_values;
                        param1=param;
                        param1(n)=param1(n)-diff_precision;
                        param2=param;
                        param2(n)=param2(n)+diff_precision;
                        %Note: data ordered [x'; pie'; r']
                        
                        DsgeLikelihood(param1,k,data,data_index,number_of_observations1,no_more_missing_observations);
                        %sigma1=diag([param1(8) param1(7) param1(9)]);
                        sigma1=eye(3);
                        temp=oo_.dr.ghx;
                        Theta1=[zeros(6,1) temp zeros(6,2)];
                        %                     temp=oo_.dr.ghx;
                        %                     Theta1=[temp(:,1) zeros(6,1) temp(:,2:3) zeros(6,2)];
                        B=oo_.dr.ghu;
                        A=[0 1 0 0 0 0;...
                            0 0 0 0 1 0;...
                            0 0 0 0 0 1];
                        H1=@(w) A*(eye(6)-Theta1*w)^-1*B;
                        f1=@(w) (eye(3)-exp(-1i*w)*Qu_LM_PW_A)*...
                            1/(2*pi)*H1(exp(-1i*w))*sigma1*H1(exp(-1i*w))'*(eye(3)-exp(-1i*w)*Qu_LM_PW_A)';
                        DsgeLikelihood(param2,k,data,data_index,number_of_observations1,no_more_missing_observations);
                        
                        sigma2=eye(3);
                        temp=oo_.dr.ghx;
                        Theta1=[zeros(6,1) temp zeros(6,2)];
                        
                        B=oo_.dr.ghu;
                        A=[0 1 0 0 0 0;...
                            0 0 0 0 1 0;...
                            0 0 0 0 0 1];
                        H=@(w) A*(eye(6)-Theta1*w)^-1*B;
                        
                        f2=@(w) (eye(3)-exp(-1i*w)*Qu_LM_PW_A)*...
                            1/(2*pi)*H(exp(-1i*w))*sigma2*H(exp(-1i*w))'*(eye(3)-exp(-1i*w)*Qu_LM_PW_A)';
                        
                        df=@(w) (f2(w)-f1(w))/(2*diff_precision);
                        
                        count=(1:(size(data,2)-1))';
                        
                        
                        wvec=2*pi*count(1:end-1,:)/(size(data,2)-1);
                        
                        for m1=1:size(wvec,1);
                            d=df(wvec(m1));
                            dstore(:,n,m1)=transpose(d(1:end));
                        end
                    end
                    param=calibrated_values;
                    DsgeLikelihood(param1,k,data,data_index,number_of_observations1,no_more_missing_observations);
                    
                    sigma0=eye(3);
                    temp=oo_.dr.ghx;
                    Theta1=[zeros(6,1) temp zeros(6,2)];
                    
                    
                    B=oo_.dr.ghu;
                    A=[0 1 0 0 0 0;...
                        0 0 0 0 1 0;...
                        0 0 0 0 0 1];
                    H0=@(w) A*(eye(6)-Theta1*w)^-1*B;
                    f0=@(w) (eye(3)-exp(-1i*w)*Qu_LM_PW_A)*...
                        1/(2*pi)*H0(exp(-1i*w))*sigma0*H0(exp(-1i*w))'*(eye(3)-exp(-1i*w)*Qu_LM_PW_A)';
                    
                    W=@(w) (2*pi*(size(data,2)-1))^-.5*transpose(sum(Y.*repmat(exp(-1i*count*w),1,3)));
                    I=@(w) W(w)*W(w)';
                    fprod=@(w) kron(transpose(f0(w)^-1),f0(w)^-1);
                    %fprod=@(w) kron((f0(w)^-1)',f0(w)^-1);
                    
                    M=zeros(sum(estim_params),sum(estim_params));
                    
                    for m1=1:size(wvec,1)
                        M=M+8*pi^2*(size(data,2)-1)^-1*dstore(:,:,m1)'*fprod(wvec(m1))*dstore(:,:,m1);
                    end
                    
                    D=zeros(sum(estim_params),1);
                    for m1=1:size(wvec,1)
                        temp=I(wvec(m1))-f0(wvec(m1));
                        D=D+2*pi*(size(data,2)-1)^-.5*dstore(:,:,m1)'*fprod(wvec(m1))*transpose(temp(1:end));
                    end
                    %D
                    %M
                    norm(D1-D)
                    norm(D1)-norm(D)
                    norm(M1^-1-M^-1)
                    Qu_LM_PW_output(n1,1)=D'*pinv(M)*D;
                end
            end
            
            
        end
    elseif composite_test==1
        DsgeLikelihood(calibrated_values',k,data,data_index,number_of_observations1,no_more_missing_observations);
        b0=lik;
        g=@likeeval;
        k2=k;
        data2=data;
        data_index2=data_index;
        number_of_observations2=number_of_observations;
        no_more_missing_observations2=no_more_missing_observations;
        testparam=calibrated_values(test_params==1);
        options=optimset('MaxIter',12000,'MaxFunEvals',12000);
        if sum(test_params)~=sum(estim_params)
            x0=calibrated_values(test_params==0&estim_params==1);
            [x,fval] = fminsearch(g,x0,options);
        else
            x=[];
        end
        param=calibrated_values';
        param(estim_params==1&test_params==0)=x;
        param(test_params==1)=testparam;
        count=(1:size(param,1))';
        countmod=count(estim_params'==1);
        loglike_list1=NaN(sum(estim_params'),size(b0,1));
        loglike_list2=NaN(sum(estim_params'),size(b0,1));
        for n=1:sum(estim_params)
            param1=param;
            param1(countmod(n))=param1(countmod(n))-diff_precision;
            param2=param;
            param2(countmod(n))=param2(countmod(n))+diff_precision;
            DsgeLikelihood(param1,k,data,data_index,number_of_observations1,no_more_missing_observations);
            b=lik;
            loglike_list1(n,:)=b';
            DsgeLikelihood(param2,k,data,data_index,number_of_observations1,no_more_missing_observations);
            b=lik;
            loglike_list2(n,:)=b';
        end
        s=(loglike_list2-loglike_list1)/(2*diff_precision);
        S=sum(s,2);
        J=s(:,1)*s(:,1)';
        for l=2:size(s,2)
            J=J+s(:,l)*s(:,l)';
        end
        if rank(J)==size(J,1);
            AM_LM_output=S'*J^-1*S;
        else
            AM_LM_output=NaN;
        end
        
        if fixJ==1 && isnan(AM_LM_output)==0
            
            if J_MC_integration==0
                paramvec=param;
                Base_model_estimation_likeeval_modified
                Phi=[zeros(6,1) oo_.dr.ghx zeros(6,2)];
                E=oo_.dr.ghu;
                H=[0 1 0 0 0 0;...
                    0 0 0 0 1 0;...
                    0 0 0 0 0 1];
                [theta, din, lab] = ss2thd(Phi, [], E, H, [], [], eye(3), [], []);
                
                [std, corrm, varm, Im] = imod(theta, din, zeros(200,3), 0);
                
                
                p.phix=param(1);
                p.phipi=param(2);
                p.alpha=param(3);
                p.rho=param(4);
                p.delta=param(5);
                p.kappa=param(6);
                p.sigmaa=param(7);
                p.sigmau=param(8);
                p.sigma=param(9);
                p.beta=.99;
                
                G0=[1 0 0 -p.rho 0 0;...
                    0 -1 1 0 (1-p.alpha)*p.phix (1-p.alpha)*p.phipi;...
                    0 0 1 0 0 0;...
                    0 0 0 1 0 0;...
                    1 -1 0 0 -1 0;...
                    0 0 0 0 p.kappa -1];
                
                
                
                G1=[0 0 0 0 0 0;...
                    0 0 0 0 0 0;...
                    0 0 0 0 0 0;...
                    0 0 0 0 0 0;...
                    0 0 0 0 -1 -1;...
                    0 0 0 0 0 -p.beta];
                
                G2=[0 0 0 0 0 0;...
                    0 -p.alpha 0 0 0 0;...
                    0 0 p.delta 0 0 0;...
                    0 0 0 p.rho 0 0;...
                    0 0 0 0 0 0;...
                    0 0 0 0 0 0];
                
                G3=[0 0 0;...
                    0 0 0;...
                    p.sigmau 0 0;...
                    0 p.sigmaa 0;...
                    0 0 0;...
                    0 0 p.sigma];
                
                dG1dt=zeros(size(G1(1:end)',1),9);
                dG2dt=zeros(size(G2(1:end)',1),9);
                dG3dt=zeros(size(G3(1:end)',1),9);
                dG0dt=zeros(size(G0(1:end)',1),9);
                
                %Set nonzero elements of dG0dt
                dG0dt(19,4)=-1;
                dG0dt(26,3)=-p.phix;
                dG0dt(26,1)=1-p.alpha;
                dG0dt(30,6)=1;
                dG0dt(32,3)=-p.phipi;
                dG0dt(32,2)=1-p.alpha;
                
                %All elements of dG1dt are zero
                
                %Set nonzero elements of dG2dt
                dG2dt(8,3)=-1;
                dG2dt(15,5)=1;
                dG2dt(22,4)=1;
                
                %Set nonzero elements of dG3dt
                dG3dt(3,8)=1;
                dG3dt(10,7)=1;
                dG3dt(18,9)=1;
                
                A=[zeros(6,1) oo_.dr.ghx zeros(6,2)];
                B=oo_.dr.ghu;
                
                dAdt=-(kron(eye(6),G0)-kron(A',G1)-kron(eye(6),G1*A))^-1*...
                    (kron(A',eye(6))*dG0dt-kron((A')*(A'),eye(6))*dG1dt-dG2dt);
                
                dBdt=(kron(eye(3),(G0-G1*A)))^-1*...
                    (dG3dt-kron(B',eye(6))*(dG0dt-kron(A',eye(6))*dG1dt-kron(eye(6),G1)*dAdt));
                
                
                dPhidt2=[dAdt; dBdt; zeros(24,9)];
                
                Jmean2=dPhidt2'*Im*dPhidt2;
                
                AM_LM_J_fixed=S'*Jmean2^-1*S;
                
            else
                paramvec=param;
                Base_model_estimation_likeeval_modified
                Phi=[zeros(6,1) oo_.dr.ghx zeros(6,2)];
                E=oo_.dr.ghu;
                H=[0 1 0 0 0 0;...
                    0 0 0 0 1 0;...
                    0 0 0 0 0 1];
                LRV=dlyap(Phi,E*E');
                Jsimstore=NaN(size(J,1),size(J,2),J_MC_reps);
                for MCsimcount=1:J_MC_reps
                    e=randn([3,size(data,1)]);
                    S=NaN(6,size(data,1));
                    S(:,1)=real(LRV^.5)*randn(6,1);
                    for k1=2:size(data,1);
                        S(:,k1)=Phi*S(:,k1-1)+E*e(:,k1);
                    end
                    obs=H*S;
                    
                    r=obs(1,:)';
                    x=obs(2,:)';
                    pie=obs(3,:)';
                    
                    data=[r x pie];
                    
                    count=(1:size(param,1))';
                    countmod=count(estim_params'==1);
                    loglike_list1=NaN(sum(estim_params'),size(b0,1));
                    loglike_list2=NaN(sum(estim_params'),size(b0,1));
                    for n=1:sum(estim_params)
                        param1=param;
                        param1(countmod(n))=param1(countmod(n))-diff_precision;
                        param2=param;
                        param2(countmod(n))=param2(countmod(n))+diff_precision;
                        DsgeLikelihood(param1,k,data,data_index,number_of_observations1,no_more_missing_observations);
                        b=lik;
                        loglike_list1(n,:)=b';
                        DsgeLikelihood(param2,k,data,data_index,number_of_observations1,no_more_missing_observations);
                        b=lik;
                        loglike_list2(n,:)=b';
                    end
                    s=(loglike_list2-loglike_list1)/(2*diff_precision);
                    S=sum(s,2);
                    J=s(:,1)*s(:,1)';
                    for l=2:size(s,2)
                        J=J+s(:,l)*s(:,l)';
                    end
                    Jsimstore(:,:,MCsimcount)=J;
                    
                end
                Jmean2=mean(Jsimstore,3);
                AM_LM_J_fixed=S'*Jmean2^-1*S;
            end
        end
        
    end
end



end




